/*
 * TismTool  Tis Veugen, 2010-2011
 * Application, Simulation, Verification
 *
 * OSAL_Thread.h
 * version 3
 */
#ifndef OSAL_THREAD_H
#define OSAL_THREAD_H

#ifdef __cplusplus
extern "C" {
#endif

#include <setjmp.h>
#include "OSAL_Gen.h"
#include <pthread.h>

typedef struct
{
  OSAL_Bool   bOccupied;
  pthread_t   Pthread;
  jmp_buf     JmpBuf;
} OSAL_Thread;

void          OSAL_ThreadInitialise( void );
void          OSAL_ThreadTerminate( void );
OSAL_Handle   OSAL_ThreadCreate( void (*pFct)(void*), void* pArg );
OSAL_Handle   OSAL_SetMainThread( void );
OSAL_Thread*  OSAL_GetCurrentThread( void );
OSAL_Handle   OSAL_GetCurrentThreadHandle( void );
void          OSAL_ThreadDelete( OSAL_Handle h );
void          OSAL_ThreadSetAffinity( OSAL_Handle h, unsigned long Mask );
void          OSAL_ThreadSleep( int MilliSeconds );
void          OSAL_ThreadYield( void );

#ifdef __cplusplus
}
#endif 
#endif
