/*
 * TismTool © Tis Veugen, 2010-2011
 * Application, Simulation, Verification
 *
 * TsmBase.c
 * version 1
 */
#include <string.h>
#include <stdio.h>
#include "TsmGen.h"
#include "TsmBase.h"

static TsmBase TsmBase0;

TsmBase* TsmBase_Ctor( void )
{
  TsmBase* pTsmBase = (TsmBase*) Tsm_Malloc( sizeof(TsmBase) );
  TsmBase_Ftor( pTsmBase );
  return pTsmBase;
}

void TsmBase_Ftor( TsmBase* this )
{
  static TsmBool bBoot = FALSE;

  if ( ! bBoot )
  {
    bBoot = TRUE;
    TsmObject_Ftor( (TsmObject*) &TsmBase0 );
    TsmBase0.Class = "TsmBase";
    TsmBase0.TsmParent = NULL;
    TsmBase0.TsmName = "";
    TsmBase0.IsTsmSubFsm = TsmBase_IsTsmSubFsm;
    TsmBase0.TotalName = TsmBase_TotalName;
    TsmBase0.FullName = TsmBase_FullName;
  }

  memcpy( this, &TsmBase0, sizeof(TsmBase) );
}

TsmBool TsmBase_IsTsmSubFsm( TsmBase* this )
{
  return FALSE;
}

void TsmBase_TotalName( TsmBase* this, TsmStr sout )
{
  *sout = '\0';

  if ( NULL != this->TsmParent )
  {
    this->TsmParent->TotalName( this->TsmParent, sout );

    if ( sout[ strlen(sout)-1 ] != '>' )
    {
      strcat( sout, " " );
    }
    strcat( sout, ">" );
    if ( strlen(this->TsmName) > 0 )
    {
      strcat( sout, " " );
    }
  }

  if ( ( this->TsmParent != NULL )
    && ( this->TsmParent->IsTsmSubFsm( this->TsmParent ) ) )
  {
    strcat( sout, "{" );
  }

  strcat( sout, this->TsmName );

  if ( ( this->TsmParent != NULL )
    && ( this->TsmParent->IsTsmSubFsm( this->TsmParent ) ) )
  {
    strcat( sout, "}" );
  }
}

void TsmBase_FullName( TsmBase* this, TsmStr sout )
{
  sprintf( sout, "( " );
  this->TotalName( this, sout+strlen(sout) );
  strcat( sout, " )" );
}
