/*
 * TismTool © Tis Veugen, 2010-2011
 * Application, Simulation, Verification
 *
 * TsmFifo_Envelope.c
 * version 1
 */
#include "TsmGen.h"
#include "TsmFifo_Envelope.h"
#include "TsmException.h"

void TsmFifo_Envelope_Initialise( TsmFifo_Envelope* this, int Size, TsmFifoValue* Items )
{
  this->Size = Size;
  this->Number = 0;
  this->Head = 0;
  this->pItems = Items;
}

void TsmFifo_Envelope_Put( TsmFifo_Envelope* this, TsmFifoValue* Value )
{
  int Tail;

  if ( this->Number >= this->Size )
  {
    TsmException_Quit( "TsmFifo_Envelope_Put: full, increase size" );
  }

  Tail = this->Head + this->Number;
  if ( Tail >= this->Size )
  {
    Tail -= this->Size;
  }
  this->pItems[Tail] = *Value;
  this->Number++;
}

TsmBool TsmFifo_Envelope_Get( TsmFifo_Envelope* this, TsmFifoValue* Value )
{
  if ( this->Number == 0 )
  {
    return FALSE;
  }

  *Value = this->pItems[this->Head];
  this->Head++;
  if ( this->Head >= this->Size )
  {
    this->Head = 0;
  }
  this->Number--;

  return TRUE;
}
