/*
 * TismTool © Tis Veugen, 2010-2011
 * Application, Simulation, Verification
 *
 * TsmList.h
 * version 1
 */
#ifndef TSM_LIST_H
#define TSM_LIST_H

#ifdef __cplusplus
extern "C" {
#endif

#include "TsmGen.h"

#define TsmList_First( pList )    (pList)->pOccupied

#define TsmListItem_Next( pLI )   (pLI)->pNext
#define TsmListItem_Value( pLI )  (pLI)->Value

typedef void* TsmListValue;

typedef struct TsmListItemStruct
{
  struct TsmListItemStruct* pNext;
  TsmListValue              Value;
} TsmListItem;

typedef struct TsmListStruct
{
  TsmListItem* pFree;
  TsmListItem* pOccupied;
} TsmList;

void    TsmList_Initialise( TsmList* this, int Size, TsmListItem* Items );
void    TsmList_Add( TsmList* this, TsmListValue Value );
TsmBool TsmList_Remove( TsmList* this, TsmListValue Value );
void    TsmList_Clear( TsmList* this );

#ifdef __cplusplus
}
#endif 
#endif
