/*
 * TismTool © Tis Veugen, 2010-2011
 * Application, Simulation, Verification
 *
 * TsmHandler.c
 * version 2
 */
#include <string.h>
#include "TsmGen.h"
#include "TsmObject.h"
#include "TsmHandler.h"
#include "TsmHandlerAction.h"
#include "TsmProspect.h"
#include "TsmTrigger.h"

TsmHandler* TsmHandler_Ctor( void )
{
  TsmHandler* this = (TsmHandler*) Tsm_Malloc( sizeof(TsmHandler) );
  TsmHandler_Ftor( this );
  return this;
}

void TsmHandler_Ftor( TsmHandler* this )
{
  TsmObject_Ftor( (TsmObject*) this );
  this->Class = "TsmHandler";
  this->Action = TsmHandlerAction_NONE;
  this->Index = -1;
  this->Prospect = TsmProspect_NOK;
  this->Index = -1;
  this->bTaken = FALSE;
  this->Owner = NULL;
  this->Trigger = NULL;
  this->TacSubFsm = NULL;
}

void TsmHandler_Ftor1( TsmHandler* this, struct TsmClassStruct* oOwner )
{
  TsmHandler_Ftor( this );
  this->Owner = oOwner;
}

void TsmHandler_Ftor2( TsmHandler* this, struct TsmClassStruct* oOwner, TsmTrigger* oTrigger )
{
  TsmHandler_Ftor( this );
  this->Owner = oOwner;
  this->Trigger = oTrigger;
}
