/*
 * TismTool © Tis Veugen, 2010-2011
 * Application, Simulation, Verification
 *
 * TsmState.h
 * version 4
 */
#ifndef TSM_STATE_H
#define TSM_STATE_H

#ifdef __cplusplus
extern "C" {
#endif

#include "TsmGen.h"
#include "TsmBase.h"
#include "TsmTransition.h"
#include "TsmProspect.h"
#include "TsmHandler.h"

typedef struct TsmStateStruct /* : TsmBase */
{
#include "TsmState_fields.h"
} TsmState;

typedef void    (*Tsm_pfStHdlr)( TsmState*, TsmHandler* );
typedef TsmBool (*Tsm_pfStHdlrBl)( TsmState*, TsmHandler* );
typedef int     (*Tsm_pfStInts)( TsmState*, int, int );

TsmState* TsmState_Ctor( void );
void      TsmState_Ftor( TsmState* this );
void      TsmState_Gtor( TsmState* this );

void      TsmState_AtEntry( TsmState* this, TsmHandler* oHandler );
void      TsmState_AtExit( TsmState* this, TsmHandler* oHandler );
void      TsmState_Initial( TsmState* this, TsmHandler* oHandler );
void      TsmState_Entrypoint( TsmState* this, TsmHandler* oHandler );
void      TsmState_ExecuteTrigger( TsmState* this, TsmHandler* oHandler );
void      TsmState_ExecuteTriggerless( TsmState* this, TsmHandler* oHandler );
TsmBool   TsmState_ExecuteTransition( TsmState* this, TsmHandler* oHandler );
void      TsmState_ExecuteHandler( TsmState* this, TsmHandler* oHandler );
int       TsmState_GetProspect( TsmState* this, int PortId, int Command );
void      TsmState_TsmSnap( TsmState* this, TsmStr sout );
void      TsmState_TsmCheckVisit( TsmState* this );
void      TsmState_Lgl( TsmState* this, int iLevel, char* s );

#ifdef __cplusplus
}
#endif 
#endif

