/*
 * TismTool © Tis Veugen, 2010-2011
 * Simulation, Verification
 *
 * TsmQueue.h
 * version 1
 */
#ifndef TSM_QUEUE_H
#define TSM_QUEUE_H

#ifdef __cplusplus
extern "C" {
#endif

#include "TsmGen.h"
#include "TsmMutex.h"
#include "TsmFifo_Envelope.h"
#include "TsmEnvelope.h"

typedef struct TsmQueueStruct
{
#include "TsmQueue_fields.h"
} TsmQueue;

TsmQueue* TsmQueue_Ctor( void );
void      TsmQueue_Ftor( TsmQueue* this );
void      TsmQueue_Gtor( TsmQueue* this );

int       TsmQueue_GetMaxQueueSize( TsmQueue* this );
int       TsmQueue_GetSeqId( TsmQueue* this );
void      TsmQueue_SetSeqId( TsmQueue* this, int SeqId );
void      TsmQueue_Put( TsmQueue* this, TsmEnvelope* oEnvelope );
TsmBool   TsmQueue_Dequeue( TsmQueue* this, TsmEnvelope* oEnvelope );
void      TsmQueue_Empty( TsmQueue* this );
int       TsmQueue_Number( TsmQueue* this );
void      TsmQueue_Snap( TsmQueue* this, TsmStr sout );

#ifdef __cplusplus
}
#endif 
#endif
