/*
 * TismTool © Tis Veugen, 2010-2011
 * Application, Simulation, Verification
 *
 * TsmRzVousSem.c
 * version 2
 */
#include "OSAL_Gen.h"
#include "OSAL_RzVousSem.h"
#include "TsmGen.h"
#include "TsmRzVousSem.h"
#include "TsmException.h"

void TsmRzVousSem_Ftor( TsmRzVousSem* this )
{
  this->mRzVous = OSAL_RzVousSemCreate();
  if ( OSAL_HANDLE_INVALID == this->mRzVous )
  {
    TsmException_Quit( "TsmRzVousSem_Ftor: OSAL_RzVousSemCreate" );
  }
  this->mbRendezVous = FALSE;
}

void TsmRzVousSem_Gtor( TsmRzVousSem* this )
{
  if ( OSAL_HANDLE_INVALID != this->mRzVous )
  {
    OSAL_RzVousSemDelete( this->mRzVous );
    this->mRzVous = OSAL_HANDLE_INVALID;
  }
}

void TsmRzVousSem_WaitOne( TsmRzVousSem* this )
{
  this->mbRendezVous = TRUE;
  OSAL_RzVousSemWait( this->mRzVous );
  this->mbRendezVous = FALSE;
}

void TsmRzVousSem_Release( TsmRzVousSem* this )
{
  OSAL_RzVousSemRelease( this->mRzVous );
}

void TsmRzVousSem_Reset( TsmRzVousSem* this )
{
  if ( this->mbRendezVous )
  {
    OSAL_RzVousSemReset( this->mRzVous );
    this->mbRendezVous = FALSE;
  }
}
