/*
 * TismTool © Tis Veugen, 2010-2011
 * Simulation, Verification
 *
 * TsmThread.h
 * version 1
 */
#ifndef TSM_THREAD_H
#define TSM_THREAD_H

#ifdef __cplusplus
extern "C" {
#endif

#include "OSAL_Gen.h"
#include "TsmGen.h"
#include "TsmThreadType.h"
#include "TsmExtQueue.h"
#include "TsmIntQueue.h"
#include "TsmEnvelope.h"
#include "TsmRvState.h"
#include "TsmMutex.h"
#include "TsmRzVousSem.h"
#include "TsmTriggerSem.h"
#include "TsmTrigger.h"

typedef struct TsmThreadStruct
{
#include "TsmThread_fields.h"
} TsmThread;

TsmThread*    TsmThread_Ctor( TsmThreadType Type );
void          TsmThread_Ftor( TsmThread* this, TsmThreadType Type );
void          TsmThread_Gtor( TsmThread* this );
void          TsmThread_Dtor( TsmThread* this );

OSAL_Handle   TsmThread_GetThread( TsmThread* this );
TsmExtQueue*  TsmThread_GetExtQueue( TsmThread* this );
TsmIntQueue*  TsmThread_GetIntQueue( TsmThread* this );
int           TsmThread_GetMaxExtQueueSize( TsmThread* this );
int           TsmThread_GetMaxIntQueueSize( TsmThread* this );
OSAL_Bool     TsmThread_HasMessage( TsmThread* this );
void          TsmThread_MaxQueueSizes( TsmThread* this, TsmStr sout );
void          TsmThread_Prepare( TsmThread* this, char* sName );
void          TsmThread_Run( TsmThread* this );
void          TsmThread_Halt( TsmThread* this );
void          TsmThread_Interrupt( TsmThread* this );
void          TsmThread_Cease( TsmThread* this );
void          TsmThread_ExclusiveLock( TsmThread* this );
void          TsmThread_ExclusiveUnlock( TsmThread* this );
void          TsmThread_ExclusiveReset( TsmThread* this );
void          TsmThread_RendezVousWait( TsmThread* this );
void          TsmThread_RendezVousNotify( TsmThread* this );
void          TsmThread_TriggerWait( TsmThread* this );
void          TsmThread_TriggerNotify( TsmThread* this );
void          TsmThread_ASyncCall( TsmThread* this, TsmEnvelope* oEnvelope );
void          TsmThread_SyncCall( TsmThread* this, TsmEnvelope* oEnvelope );
TsmRvState    TsmThread_Handle( TsmThread* this, TsmEnvelope* oEnvelope );
void          TsmThread_NativeCall( TsmThread* this, TsmEnvelope* oEnvelope );
void          TsmThread_CbHandle( TsmThread* this, TsmEnvelope* oEnvelope );
void          TsmThread_TsmReset1( TsmThread* this );
void          TsmThread_TsmReset2( TsmThread* this );
void          TsmThread_Snap( TsmThread* this, TsmStr sout );
char*         TsmThread_GetName( TsmThread* this );
void          TsmThread_SetName( TsmThread* this, char* s );

#ifdef __cplusplus
}
#endif 
#endif
