/*
 * TismTool © Tis Veugen, 2010-2011
 * Simulation, Verification
 *
 * TsmThread_fields.h
 * version 2
 */
#include "TsmObject_fields.h"

TsmThreadType   mType;
int             mSequence;
TsmBool         mbHalt;
TsmExtQueue     mExternalQueue;
TsmIntQueue     mInternalQueue;
OSAL_Handle     mThread;
TsmMutex        mExclusiveMutex;
TsmRzVousSem    mRendezVousSem;
TsmTriggerSem   mTriggerSem;
OSAL_Handle     mRendezVousThreadBid;
char            mName[ TSM_NCH_THREADNAME ];
TsmTrigger*     mPendingTrigger;
TsmTrigger*     mLocalTrigger;

OSAL_Handle   (*GetThread)( struct TsmThreadStruct* this );
TsmExtQueue*  (*GetExtQueue)( struct TsmThreadStruct* this );
TsmIntQueue*  (*GetIntQueue)( struct TsmThreadStruct* this );
int           (*GetMaxExtQueueSize)( struct TsmThreadStruct* this );
int           (*GetMaxIntQueueSize)( struct TsmThreadStruct* this );
OSAL_Bool     (*HasMessage)( struct TsmThreadStruct* this );
void          (*MaxQueueSizes)( struct TsmThreadStruct* this, TsmStr sout );
void          (*Prepare)( struct TsmThreadStruct* this, char* sName );
void          (*Run)( struct TsmThreadStruct* this );
void          (*Halt)( struct TsmThreadStruct* this );
void          (*Interrupt)( struct TsmThreadStruct* this );
void          (*Cease)( struct TsmThreadStruct* this );
void          (*ExclusiveLock)( struct TsmThreadStruct* this );
void          (*ExclusiveUnlock)( struct TsmThreadStruct* this );
void          (*ExclusiveReset)( struct TsmThreadStruct* this );
void          (*RendezVousWait)( struct TsmThreadStruct* this );
void          (*RendezVousNotify)( struct TsmThreadStruct* this );
void          (*TriggerWait)( struct TsmThreadStruct* this );
void          (*TriggerNotify)( struct TsmThreadStruct* this );
void          (*ASyncCall)( struct TsmThreadStruct* this, TsmEnvelope* oEnvelope );
void          (*SyncCall)( struct TsmThreadStruct* this, TsmEnvelope* oEnvelope );
TsmRvState    (*Handle)( struct TsmThreadStruct* this, TsmEnvelope* oEnvelope );
void          (*NativeCall)( struct TsmThreadStruct* this, TsmEnvelope* oEnvelope );
void          (*CbHandle)( struct TsmThreadStruct* this, TsmEnvelope* oEnvelope );
void          (*TsmReset1)( struct TsmThreadStruct* this );
void          (*TsmReset2)( struct TsmThreadStruct* this );
void          (*Snap)( struct TsmThreadStruct* this, TsmStr sout );
char*         (*GetName)( struct TsmThreadStruct* this );
void          (*SetName)( struct TsmThreadStruct* this, char* s );
