/*
 * TismTool © Tis Veugen, 2010-2011
 * Application, Simulation, Verification
 *
 * TsmTriggerSem.c
 * version 1
 */
#include "OSAL_Gen.h"
#include "OSAL_TriggerSem.h"
#include "TsmGen.h"
#include "TsmTriggerSem.h"
#include "TsmException.h"

void TsmTriggerSem_Ftor( TsmTriggerSem* this )
{
  this->mTrigger = OSAL_TriggerSemCreate();
  if ( OSAL_HANDLE_INVALID == this->mTrigger )
  {
    TsmException_Quit( "TsmTriggerSem_Ftor: OSAL_TriggerSemCreate" );
  }
}

void TsmTriggerSem_Gtor( TsmTriggerSem* this )
{
  if ( OSAL_HANDLE_INVALID != this->mTrigger )
  {
    OSAL_TriggerSemDelete( this->mTrigger );
    this->mTrigger = OSAL_HANDLE_INVALID;
  }
}

void TsmTriggerSem_WaitOne( TsmTriggerSem* this )
{
  OSAL_TriggerSemWait( this->mTrigger );
}

void TsmTriggerSem_Release( TsmTriggerSem* this )
{
  OSAL_TriggerSemRelease( this->mTrigger );
}
