/*
 * File: TsmSystem.h
 * Date: 19 aug 2011
 * Time: 18:14:40
 * Generated by TismTool version 0.7
 */

/*
 * Overview of identifications
 * ---------------------------
 * Ports:
 *     21 ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > rp_In2 )
 *     45 ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > rp_In )
 *     47 ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > rp_Oracle )
 *     74 ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > Pythia )
 *     90 ( Xmi > Data > Protocols > OracleProtocol > OracleClient > Port )
 *    100 ( Xmi > Data > Protocols > OracleProtocol > OracleServer > Port )
 *    120 ( Xmi > Data > Protocols > TwinProtocol > TwinClient > Port )
 * Triggers:
 *      1 void ICbTwin___CbQuestion( String sQuestion )
 *      2 void ICbTwin___CbAnswer( String sAnswer )
 *      3 void ICbOracle___CbReply( String sReply )
 *      4 void IOracle___Ask( String sAsk )
 * Natives:
 *     32 ( TwinMockFsm >> CompoundState >> Idle ) ->
 *        ( TwinMockFsm >> CompoundState >> Asking )
 *        pp_Out2->CbQuestion(\"My question?\");
 *     40 ( TwinMockFsm >> CompoundState >> Thinking ) ->
 *        ( TwinMockFsm >> CompoundState >> Answered )
 *        pp_Out2->CbAnswer(\"My answer!\");
 *    -97 ( OracleClientPsm >> Idle ) ->
 *        ( OracleClientPsm >> Asking )
 *        Ask( sAsk );
 *    108 ( OracleServerPsm >> Asked ) ->
 *        ( OracleServerPsm >> Idle )
 *        sprintf( MyReply, \"This is answer of '%s' !\", MyAsk );#CbReply( MyReply );
 *    117 ( TwinServerPsm >> Idle ) ->
 *        ( TwinServerPsm >> Idle )
 *        CbQuestion(sQuestion);
 *    118 ( TwinServerPsm >> Idle ) ->
 *        ( TwinServerPsm >> Idle )
 *        CbAnswer(sAnswer);
 */

#ifndef TSM_SYSTEM_H
#define TSM_SYSTEM_H

#ifdef __cplusplus
extern "C" {
#endif

#include "TsmIncludes.h"
#include "TsmInterfaces.h"
/* Included from file: C:\WORKSPACES\ECLIPSE_H_CPP\L_TWINS_C\Twins_C.h */
typedef char CharArray[128];


/********************************************************************
 * PACKAGE: ( Xmi > UML Standard Profile > StandardProfileL2 )
 ********************************************************************/

 /* ( Xmi > UML Standard Profile > StandardProfileL2 ) */
typedef struct Pac_0001_0002Struct
{
#include "TsmPackage_fields.h"
} Pac_0001_0002;

Pac_0001_0002* Pac_0001_0002_Ctor( TsmBase* oParent );

/********************************************************************
 * PACKAGE: ( Xmi > UML Standard Profile > MagicDraw Profile > datatypes )
 ********************************************************************/

 /* ( Xmi > UML Standard Profile > MagicDraw Profile > datatypes ) */
typedef struct Pac_0003_0004Struct
{
#include "TsmPackage_fields.h"
} Pac_0003_0004;

Pac_0003_0004* Pac_0003_0004_Ctor( TsmBase* oParent );

/********************************************************************
 * PACKAGE: ( Xmi > UML Standard Profile > MagicDraw Profile )
 ********************************************************************/

 /* ( Xmi > UML Standard Profile > MagicDraw Profile ) */
typedef struct Pac_0001_0003Struct
{
#include "TsmPackage_fields.h"
} Pac_0001_0003;

Pac_0001_0003* Pac_0001_0003_Ctor( TsmBase* oParent );

/********************************************************************
 * PACKAGE: ( Xmi > UML Standard Profile > StandardProfileL3 )
 ********************************************************************/

 /* ( Xmi > UML Standard Profile > StandardProfileL3 ) */
typedef struct Pac_0001_0005Struct
{
#include "TsmPackage_fields.h"
} Pac_0001_0005;

Pac_0001_0005* Pac_0001_0005_Ctor( TsmBase* oParent );

 /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> InitialState ) */
typedef struct Ini_0049_0050Struct
{
#include "TsmPseudo_fields.h"
  TsmTransition* aTransitions[ 1 ];
} Ini_0049_0050;

Ini_0049_0050* Ini_0049_0050_Ctor( TsmBase* oParent );
void Ini_0049_0050_Initial( struct Ini_0049_0050Struct* this, TsmHandler* oHandler );
void Ini_0049_0050_AtEntry( struct Ini_0049_0050Struct* this, TsmHandler* oHandler );
TsmBool Ini_0049_0050_ExecuteTransition( struct Ini_0049_0050Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> InitialState ) */
typedef struct Ini_0052_0053Struct
{
#include "TsmPseudo_fields.h"
  TsmTransition* aTransitions[ 1 ];
} Ini_0052_0053;

Ini_0052_0053* Ini_0052_0053_Ctor( TsmBase* oParent );
void Ini_0052_0053_Initial( struct Ini_0052_0053Struct* this, TsmHandler* oHandler );
void Ini_0052_0053_AtEntry( struct Ini_0052_0053Struct* this, TsmHandler* oHandler );
TsmBool Ini_0052_0053_ExecuteTransition( struct Ini_0052_0053Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> FinalState ) */
typedef struct Fin_0052_0054Struct
{
#include "TsmFinal_fields.h"
} Fin_0052_0054;

Fin_0052_0054* Fin_0052_0054_Ctor( TsmBase* oParent );
void Fin_0052_0054_Tra_0052_0062( struct Fin_0052_0054Struct* this, TsmHandler* oHandler );
void Fin_0052_0054_AtEntry( struct Fin_0052_0054Struct* this, TsmHandler* oHandler );
TsmBool Fin_0052_0054_ExecuteTransition( struct Fin_0052_0054Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> ChoiceState ) */
typedef struct Cho_0052_0055Struct
{
#include "TsmPseudo_fields.h"
  TsmTransition* aTransitions[ 2 ];
} Cho_0052_0055;

Cho_0052_0055* Cho_0052_0055_Ctor( TsmBase* oParent );
void Cho_0052_0055_Initial( struct Cho_0052_0055Struct* this, TsmHandler* oHandler );
void Cho_0052_0055_Tra_0052_0061( struct Cho_0052_0055Struct* this, TsmHandler* oHandler );
void Cho_0052_0055_AtEntry( struct Cho_0052_0055Struct* this, TsmHandler* oHandler );
TsmBool Cho_0052_0055_ExecuteTransition( struct Cho_0052_0055Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> Idle ) */
typedef struct Lea_0052_0056Struct
{
#include "TsmLeaf_fields.h"
  TsmTransition* aTransitions[ 1 ];
} Lea_0052_0056;

Lea_0052_0056* Lea_0052_0056_Ctor( TsmBase* oParent );
void Lea_0052_0056_Tra_0052_0058( struct Lea_0052_0056Struct* this, TsmHandler* oHandler );
void Lea_0052_0056_Initial( struct Lea_0052_0056Struct* this, TsmHandler* oHandler );
void Lea_0052_0056_Tra_0052_0059( struct Lea_0052_0056Struct* this, TsmHandler* oHandler );
void Lea_0052_0056_AtEntry( struct Lea_0052_0056Struct* this, TsmHandler* oHandler );
TsmBool Lea_0052_0056_ExecuteTransition( struct Lea_0052_0056Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> Asking ) */
typedef struct Lea_0052_0057Struct
{
#include "TsmLeaf_fields.h"
  TsmTransition* aTransitions[ 1 ];
} Lea_0052_0057;

Lea_0052_0057* Lea_0052_0057_Ctor( TsmBase* oParent );
void Lea_0052_0057_Tra_0052_0060( struct Lea_0052_0057Struct* this, TsmHandler* oHandler );
void Lea_0052_0057_Initial( struct Lea_0052_0057Struct* this, TsmHandler* oHandler );
void Lea_0052_0057_rp_In___CbAnswer( struct Lea_0052_0057Struct* this, char* sAnswer, TsmHandler* oHandler );
void Lea_0052_0057_AtEntry( struct Lea_0052_0057Struct* this, TsmHandler* oHandler );
int Lea_0052_0057_GetProspect( struct Lea_0052_0057Struct* this, int PortId, int Command );
void Lea_0052_0057_ExecuteTrigger( struct Lea_0052_0057Struct* this, TsmHandler* oHandler );
TsmBool Lea_0052_0057_ExecuteTransition( struct Lea_0052_0057Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >) */
typedef struct Reg_0051_0052Struct
{
#include "TsmRegion_fields.h"
  Ini_0052_0053* oIni_0052_0053; /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> InitialState ) */
  Fin_0052_0054* oFin_0052_0054; /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> FinalState ) */
  Cho_0052_0055* oCho_0052_0055; /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> ChoiceState ) */
  Lea_0052_0056* oLea_0052_0056; /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> Idle ) */
  Lea_0052_0057* oLea_0052_0057; /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> Asking ) */
  TsmState* aStates[ 5 ];
} Reg_0051_0052;

Reg_0051_0052* Reg_0051_0052_Ctor( TsmBase* oParent );
void Reg_0051_0052_Initial( struct Reg_0051_0052Struct* this, TsmHandler* oHandler );
void Reg_0051_0052_Tra_0052_0058( struct Reg_0051_0052Struct* this, TsmHandler* oHandler );
void Reg_0051_0052_Tra_0052_0060( struct Reg_0051_0052Struct* this, TsmHandler* oHandler );
void Reg_0051_0052_Tra_0052_0062( struct Reg_0051_0052Struct* this, TsmHandler* oHandler );
void Reg_0051_0052_Tra_0052_0061( struct Reg_0051_0052Struct* this, TsmHandler* oHandler );
void Reg_0051_0052_Tra_0052_0059( struct Reg_0051_0052Struct* this, TsmHandler* oHandler );
int Reg_0051_0052_GetProspect( struct Reg_0051_0052Struct* this, int PortId, int Command );
TsmBool Reg_0051_0052_ExecuteTransition( struct Reg_0051_0052Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> InitialState ) */
typedef struct Ini_0063_0064Struct
{
#include "TsmPseudo_fields.h"
  TsmTransition* aTransitions[ 1 ];
} Ini_0063_0064;

Ini_0063_0064* Ini_0063_0064_Ctor( TsmBase* oParent );
void Ini_0063_0064_Initial( struct Ini_0063_0064Struct* this, TsmHandler* oHandler );
void Ini_0063_0064_AtEntry( struct Ini_0063_0064Struct* this, TsmHandler* oHandler );
TsmBool Ini_0063_0064_ExecuteTransition( struct Ini_0063_0064Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> Answered ) */
typedef struct Lea_0063_0065Struct
{
#include "TsmLeaf_fields.h"
  TsmTransition* aTransitions[ 1 ];
} Lea_0063_0065;

Lea_0063_0065* Lea_0063_0065_Ctor( TsmBase* oParent );
void Lea_0063_0065_Tra_0063_0067( struct Lea_0063_0065Struct* this, TsmHandler* oHandler );
void Lea_0063_0065_Initial( struct Lea_0063_0065Struct* this, TsmHandler* oHandler );
void Lea_0063_0065_rp_In___CbQuestion( struct Lea_0063_0065Struct* this, char* sQuestion, TsmHandler* oHandler );
void Lea_0063_0065_Tra_0063_0069( struct Lea_0063_0065Struct* this, TsmHandler* oHandler );
void Lea_0063_0065_AtEntry( struct Lea_0063_0065Struct* this, TsmHandler* oHandler );
int Lea_0063_0065_GetProspect( struct Lea_0063_0065Struct* this, int PortId, int Command );
void Lea_0063_0065_ExecuteTrigger( struct Lea_0063_0065Struct* this, TsmHandler* oHandler );
TsmBool Lea_0063_0065_ExecuteTransition( struct Lea_0063_0065Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> Thinking ) */
typedef struct Lea_0063_0066Struct
{
#include "TsmLeaf_fields.h"
  TsmTransition* aTransitions[ 1 ];
} Lea_0063_0066;

Lea_0063_0066* Lea_0063_0066_Ctor( TsmBase* oParent );
void Lea_0063_0066_Initial( struct Lea_0063_0066Struct* this, TsmHandler* oHandler );
void Lea_0063_0066_Tra_0063_0068( struct Lea_0063_0066Struct* this, TsmHandler* oHandler );
void Lea_0063_0066_rp_Oracle___CbReply( struct Lea_0063_0066Struct* this, char* sReply, TsmHandler* oHandler );
void Lea_0063_0066_AtEntry( struct Lea_0063_0066Struct* this, TsmHandler* oHandler );
int Lea_0063_0066_GetProspect( struct Lea_0063_0066Struct* this, int PortId, int Command );
void Lea_0063_0066_ExecuteTrigger( struct Lea_0063_0066Struct* this, TsmHandler* oHandler );
TsmBool Lea_0063_0066_ExecuteTransition( struct Lea_0063_0066Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >) */
typedef struct Reg_0051_0063Struct
{
#include "TsmRegion_fields.h"
  Ini_0063_0064* oIni_0063_0064; /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> InitialState ) */
  Lea_0063_0065* oLea_0063_0065; /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> Answered ) */
  Lea_0063_0066* oLea_0063_0066; /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >> Thinking ) */
  TsmState* aStates[ 3 ];
} Reg_0051_0063;

Reg_0051_0063* Reg_0051_0063_Ctor( TsmBase* oParent );
void Reg_0051_0063_Initial( struct Reg_0051_0063Struct* this, TsmHandler* oHandler );
void Reg_0051_0063_Tra_0063_0067( struct Reg_0051_0063Struct* this, TsmHandler* oHandler );
void Reg_0051_0063_Tra_0063_0068( struct Reg_0051_0063Struct* this, TsmHandler* oHandler );
void Reg_0051_0063_Tra_0063_0069( struct Reg_0051_0063Struct* this, TsmHandler* oHandler );
int Reg_0051_0063_GetProspect( struct Reg_0051_0063Struct* this, int PortId, int Command );
TsmBool Reg_0051_0063_ExecuteTransition( struct Reg_0051_0063Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState ) */
typedef struct Com_0049_0051Struct
{
#include "TsmCompound_fields.h"
  Reg_0051_0052* oReg_0051_0052; /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >) */
  Reg_0051_0063* oReg_0051_0063; /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState >) */
  TsmRegion* aRegions[ 2 ];
} Com_0049_0051;

Com_0049_0051* Com_0049_0051_Ctor( TsmBase* oParent );
void Com_0049_0051_Tra_0049_0070( struct Com_0049_0051Struct* this, TsmHandler* oHandler );
void Com_0049_0051_AtEntry( struct Com_0049_0051Struct* this, TsmHandler* oHandler );
TsmBool Com_0049_0051_ExecuteTransition( struct Com_0049_0051Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >) */
typedef struct Reg_0048_0049Struct
{
#include "TsmRegion_fields.h"
  Ini_0049_0050* oIni_0049_0050; /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> InitialState ) */
  Com_0049_0051* oCom_0049_0051; /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >> CompoundState ) */
  TsmState* aStates[ 2 ];
} Reg_0048_0049;

Reg_0048_0049* Reg_0048_0049_Ctor( TsmBase* oParent );
void Reg_0048_0049_Initial( struct Reg_0048_0049Struct* this, TsmHandler* oHandler );
void Reg_0048_0049_Tra_0049_0070( struct Reg_0048_0049Struct* this, TsmHandler* oHandler );
int Reg_0048_0049_GetProspect( struct Reg_0048_0049Struct* this, int PortId, int Command );
TsmBool Reg_0048_0049_ExecuteTransition( struct Reg_0048_0049Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm ) */
typedef struct Fsm_0044_0048Struct
{
#include "TsmFsm_fields.h"
  Reg_0048_0049* oReg_0048_0049; /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm >) */
  TsmRegion* aRegions[ 1 ];
} Fsm_0044_0048;

Fsm_0044_0048* Fsm_0044_0048_Ctor( TsmBase* oParent );
void Fsm_0044_0048_AtEntry( struct Fsm_0044_0048Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass ) */
typedef struct Cla_0042_0044Struct
{
#include "TsmClass_fields.h"
  Fsm_0044_0048* oFsm_0044_0048; /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > ActorFsm ) */
  TsmIPort_ICbTwin* TsmPI__rp_In; /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > rp_In ) */
  TsmIPort_ICbTwin* pp_Out; /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > pp_Out ) */
  TsmIPort_IOracle* rp_Oracle; /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > rp_Oracle ) */
  TsmIPort_ICbOracle* TsmPI__rp_Oracle; /* ( Xmi > Data > Repository > Twin > ActorComponent > ActorClass > rp_Oracle ) */
  TsmPCPort mPCMessager;
  int MaxNumQuestion;
  int NumQuestion;
  CharArray SentQuestion;
  TsmFsm* aFsms[ 1 ];
} Cla_0042_0044;

Cla_0042_0044* Cla_0042_0044_Ctor( TsmBase* oParent, char* sInstanceName );
TsmInterfacePort* Cla_0042_0044_GetProvidedInterface( struct Cla_0042_0044Struct* this, char* sPortName );
void Cla_0042_0044_SetRequiredInterface( struct Cla_0042_0044Struct* this, char* sPortName, TsmInterfacePort* oProvidedInterface );
void Cla_0042_0044_ExecuteTrigger( struct Cla_0042_0044Struct* this, TsmTrigger* oTrigger );
void Cla_0042_0044_Function_1001( struct Cla_0042_0044Struct* this, TsmHandler* oHandler );
TsmBool Cla_0042_0044_Guard_1002( struct Cla_0042_0044Struct* this );
void Cla_0042_0044_Function_1003( struct Cla_0042_0044Struct* this, TsmHandler* oHandler );
void Cla_0042_0044_Function_1004( struct Cla_0042_0044Struct* this, TsmHandler* oHandler );
void Cla_0042_0044_Function_1005( struct Cla_0042_0044Struct* this, TsmHandler* oHandler );
void Cla_0042_0044_Function_1013( struct Cla_0042_0044Struct* this, TsmHandler* oHandler );
void Cla_0042_0044_Function_1014( struct Cla_0042_0044Struct* this, TsmHandler* oHandler );
void Cla_0042_0044_Function_1015( struct Cla_0042_0044Struct* this, TsmHandler* oHandler );
void Cla_0042_0044_TsmInitialise( struct Cla_0042_0044Struct* this, void* oObject );
void Cla_0042_0044_TsmConnect( struct Cla_0042_0044Struct* this, void* oObject );
void Cla_0042_0044_TsmPrepare( struct Cla_0042_0044Struct* this, void* oObject );
void Cla_0042_0044_Gtor( struct Cla_0042_0044Struct* this );

 /* ( Xmi > Data > Repository > Twin > ActorComponent ) */
typedef struct Com_0016_0042Struct
{
#include "TsmPComponent_fields.h"
  TsmClass* aClasses[ 1 ];
  Cla_0042_0044* Actor; /* ( Xmi > Data > Repository > Twin > ActorComponent > Actor ) */
} Com_0016_0042;

Com_0016_0042* Com_0016_0042_Ctor( TsmBase* oParent, char* sInstanceName );
TsmInterfacePort* Com_0016_0042_GetProvidedInterface( struct Com_0016_0042Struct* this, char* sPortName );
void Com_0016_0042_SetRequiredInterface( struct Com_0016_0042Struct* this, char* sPortName, TsmInterfacePort* oProvidedInterface );

 /* ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm >> InitialState ) */
typedef struct Ini_0076_0077Struct
{
#include "TsmPseudo_fields.h"
  TsmTransition* aTransitions[ 1 ];
} Ini_0076_0077;

Ini_0076_0077* Ini_0076_0077_Ctor( TsmBase* oParent );
void Ini_0076_0077_Initial( struct Ini_0076_0077Struct* this, TsmHandler* oHandler );
void Ini_0076_0077_AtEntry( struct Ini_0076_0077Struct* this, TsmHandler* oHandler );
TsmBool Ini_0076_0077_ExecuteTransition( struct Ini_0076_0077Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm >> Idle ) */
typedef struct Lea_0076_0078Struct
{
#include "TsmLeaf_fields.h"
  TsmTransition* aTransitions[ 1 ];
} Lea_0076_0078;

Lea_0076_0078* Lea_0076_0078_Ctor( TsmBase* oParent );
void Lea_0076_0078_Tra_0076_0080( struct Lea_0076_0078Struct* this, TsmHandler* oHandler );
void Lea_0076_0078_Initial( struct Lea_0076_0078Struct* this, TsmHandler* oHandler );
void Lea_0076_0078_Tra_0076_0082( struct Lea_0076_0078Struct* this, TsmHandler* oHandler );
void Lea_0076_0078_Pythia___Ask( struct Lea_0076_0078Struct* this, char* sAsk, TsmHandler* oHandler );
void Lea_0076_0078_AtEntry( struct Lea_0076_0078Struct* this, TsmHandler* oHandler );
int Lea_0076_0078_GetProspect( struct Lea_0076_0078Struct* this, int PortId, int Command );
void Lea_0076_0078_ExecuteTrigger( struct Lea_0076_0078Struct* this, TsmHandler* oHandler );
TsmBool Lea_0076_0078_ExecuteTransition( struct Lea_0076_0078Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm >> Asked ) */
typedef struct Lea_0076_0079Struct
{
#include "TsmLeaf_fields.h"
  TsmTransition* aTransitions[ 1 ];
} Lea_0076_0079;

Lea_0076_0079* Lea_0076_0079_Ctor( TsmBase* oParent );
void Lea_0076_0079_Initial( struct Lea_0076_0079Struct* this, TsmHandler* oHandler );
void Lea_0076_0079_Tra_0076_0081( struct Lea_0076_0079Struct* this, TsmHandler* oHandler );
void Lea_0076_0079_AtEntry( struct Lea_0076_0079Struct* this, TsmHandler* oHandler );
TsmBool Lea_0076_0079_ExecuteTransition( struct Lea_0076_0079Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm >) */
typedef struct Reg_0075_0076Struct
{
#include "TsmRegion_fields.h"
  Ini_0076_0077* oIni_0076_0077; /* ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm >> InitialState ) */
  Lea_0076_0078* oLea_0076_0078; /* ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm >> Idle ) */
  Lea_0076_0079* oLea_0076_0079; /* ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm >> Asked ) */
  TsmState* aStates[ 3 ];
} Reg_0075_0076;

Reg_0075_0076* Reg_0075_0076_Ctor( TsmBase* oParent );
void Reg_0075_0076_Initial( struct Reg_0075_0076Struct* this, TsmHandler* oHandler );
void Reg_0075_0076_Tra_0076_0080( struct Reg_0075_0076Struct* this, TsmHandler* oHandler );
void Reg_0075_0076_Tra_0076_0082( struct Reg_0075_0076Struct* this, TsmHandler* oHandler );
void Reg_0075_0076_Tra_0076_0081( struct Reg_0075_0076Struct* this, TsmHandler* oHandler );
int Reg_0075_0076_GetProspect( struct Reg_0075_0076Struct* this, int PortId, int Command );
TsmBool Reg_0075_0076_ExecuteTransition( struct Reg_0075_0076Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm ) */
typedef struct Fsm_0073_0075Struct
{
#include "TsmFsm_fields.h"
  Reg_0075_0076* oReg_0075_0076; /* ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm >) */
  TsmRegion* aRegions[ 1 ];
} Fsm_0073_0075;

Fsm_0073_0075* Fsm_0073_0075_Ctor( TsmBase* oParent );
void Fsm_0073_0075_AtEntry( struct Fsm_0073_0075Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass ) */
typedef struct Cla_0071_0073Struct
{
#include "TsmClass_fields.h"
  Fsm_0073_0075* oFsm_0073_0075; /* ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > OracleFsm ) */
  TsmIPort_IOracle* TsmPI__Pythia; /* ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > Pythia ) */
  TsmIPort_ICbOracle* Pythia; /* ( Xmi > Data > Repository > Twin > OracleComponent > OracleClass > Pythia ) */
  TsmPSPort mPSMessager;
  char* MyAsk;
  CharArray MyReply;
  TsmFsm* aFsms[ 1 ];
} Cla_0071_0073;

Cla_0071_0073* Cla_0071_0073_Ctor( TsmBase* oParent, char* sInstanceName );
TsmInterfacePort* Cla_0071_0073_GetProvidedInterface( struct Cla_0071_0073Struct* this, char* sPortName );
void Cla_0071_0073_SetRequiredInterface( struct Cla_0071_0073Struct* this, char* sPortName, TsmInterfacePort* oProvidedInterface );
void Cla_0071_0073_ExecuteTrigger( struct Cla_0071_0073Struct* this, TsmTrigger* oTrigger );
void Cla_0071_0073_Function_1006( struct Cla_0071_0073Struct* this, TsmHandler* oHandler );
void Cla_0071_0073_Function_1016( struct Cla_0071_0073Struct* this, TsmHandler* oHandler );
void Cla_0071_0073_TsmInitialise( struct Cla_0071_0073Struct* this, void* oObject );
void Cla_0071_0073_TsmConnect( struct Cla_0071_0073Struct* this, void* oObject );
void Cla_0071_0073_TsmPrepare( struct Cla_0071_0073Struct* this, void* oObject );
void Cla_0071_0073_Gtor( struct Cla_0071_0073Struct* this );

 /* ( Xmi > Data > Repository > Twin > OracleComponent ) */
typedef struct Com_0016_0071Struct
{
#include "TsmPComponent_fields.h"
  TsmClass* aClasses[ 1 ];
  Cla_0071_0073* Delphi; /* ( Xmi > Data > Repository > Twin > OracleComponent > Delphi ) */
} Com_0016_0071;

Com_0016_0071* Com_0016_0071_Ctor( TsmBase* oParent, char* sInstanceName );
TsmInterfacePort* Com_0016_0071_GetProvidedInterface( struct Com_0016_0071Struct* this, char* sPortName );
void Com_0016_0071_SetRequiredInterface( struct Com_0016_0071Struct* this, char* sPortName, TsmInterfacePort* oProvidedInterface );

 /* ( Xmi > Data > Repository > Twin > TwinComponent ) */
typedef struct Com_0016_0083Struct
{
#include "TsmAComponent_fields.h"
  TsmComponent* aComponents[ 2 ];
  Com_0016_0042* ActorComp; /* ( Xmi > Data > Repository > Twin > TwinComponent > ActorComp ) */
  Com_0016_0071* OracleComp; /* ( Xmi > Data > Repository > Twin > TwinComponent > OracleComp ) */
  TsmIPort_ICbTwin* TsmPI__In; /* ( Xmi > Data > Repository > Twin > TwinComponent > In ) */
  TsmACPort TsmMr__In;
} Com_0016_0083;

Com_0016_0083* Com_0016_0083_Ctor( TsmBase* oParent, char* sInstanceName );
TsmInterfacePort* Com_0016_0083_GetProvidedInterface( struct Com_0016_0083Struct* this, char* sPortName );
void Com_0016_0083_SetRequiredInterface( struct Com_0016_0083Struct* this, char* sPortName, TsmInterfacePort* oProvidedInterface );
void Com_0016_0083_TsmInitialise( struct Com_0016_0083Struct* this, void* oObject );
void Com_0016_0083_TsmConnect( struct Com_0016_0083Struct* this, void* oObject );
void Com_0016_0083_Gtor( struct Com_0016_0083Struct* this );

 /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> InitialState ) */
typedef struct Ini_0024_0025Struct
{
#include "TsmPseudo_fields.h"
  TsmTransition* aTransitions[ 1 ];
} Ini_0024_0025;

Ini_0024_0025* Ini_0024_0025_Ctor( TsmBase* oParent );
void Ini_0024_0025_Initial( struct Ini_0024_0025Struct* this, TsmHandler* oHandler );
void Ini_0024_0025_AtEntry( struct Ini_0024_0025Struct* this, TsmHandler* oHandler );
TsmBool Ini_0024_0025_ExecuteTransition( struct Ini_0024_0025Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> InitialState ) */
typedef struct Ini_0027_0028Struct
{
#include "TsmPseudo_fields.h"
  TsmTransition* aTransitions[ 1 ];
} Ini_0027_0028;

Ini_0027_0028* Ini_0027_0028_Ctor( TsmBase* oParent );
void Ini_0027_0028_Initial( struct Ini_0027_0028Struct* this, TsmHandler* oHandler );
void Ini_0027_0028_AtEntry( struct Ini_0027_0028Struct* this, TsmHandler* oHandler );
TsmBool Ini_0027_0028_ExecuteTransition( struct Ini_0027_0028Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> Idle ) */
typedef struct Lea_0027_0029Struct
{
#include "TsmLeaf_fields.h"
  const int* aNatives;
  TsmTransition* aTransitions[ 1 ];
} Lea_0027_0029;

Lea_0027_0029* Lea_0027_0029_Ctor( TsmBase* oParent );
void Lea_0027_0029_Tra_0027_0031( struct Lea_0027_0029Struct* this, TsmHandler* oHandler );
void Lea_0027_0029_Initial( struct Lea_0027_0029Struct* this, TsmHandler* oHandler );
void Lea_0027_0029_Tra_0027_0033( struct Lea_0027_0029Struct* this, TsmHandler* oHandler );
void Lea_0027_0029_AtEntry( struct Lea_0027_0029Struct* this, TsmHandler* oHandler );
void Lea_0027_0029_AtExit( struct Lea_0027_0029Struct* this, TsmHandler* oHandler );
int Lea_0027_0029_GetProspect( struct Lea_0027_0029Struct* this, int PortId, int Command );
void Lea_0027_0029_ExecuteTrigger( struct Lea_0027_0029Struct* this, TsmHandler* oHandler );
TsmBool Lea_0027_0029_ExecuteTransition( struct Lea_0027_0029Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> Asking ) */
typedef struct Lea_0027_0030Struct
{
#include "TsmLeaf_fields.h"
  TsmTransition* aTransitions[ 1 ];
} Lea_0027_0030;

Lea_0027_0030* Lea_0027_0030_Ctor( TsmBase* oParent );
void Lea_0027_0030_Initial( struct Lea_0027_0030Struct* this, TsmHandler* oHandler );
void Lea_0027_0030_Tra_0027_0032( struct Lea_0027_0030Struct* this, TsmHandler* oHandler );
void Lea_0027_0030_rp_In2___CbAnswer( struct Lea_0027_0030Struct* this, char* sAnswer, TsmHandler* oHandler );
void Lea_0027_0030_AtEntry( struct Lea_0027_0030Struct* this, TsmHandler* oHandler );
int Lea_0027_0030_GetProspect( struct Lea_0027_0030Struct* this, int PortId, int Command );
void Lea_0027_0030_ExecuteTrigger( struct Lea_0027_0030Struct* this, TsmHandler* oHandler );
TsmBool Lea_0027_0030_ExecuteTransition( struct Lea_0027_0030Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >) */
typedef struct Reg_0026_0027Struct
{
#include "TsmRegion_fields.h"
  Ini_0027_0028* oIni_0027_0028; /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> InitialState ) */
  Lea_0027_0029* oLea_0027_0029; /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> Idle ) */
  Lea_0027_0030* oLea_0027_0030; /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> Asking ) */
  TsmState* aStates[ 3 ];
} Reg_0026_0027;

Reg_0026_0027* Reg_0026_0027_Ctor( TsmBase* oParent );
void Reg_0026_0027_Initial( struct Reg_0026_0027Struct* this, TsmHandler* oHandler );
void Reg_0026_0027_Tra_0027_0031( struct Reg_0026_0027Struct* this, TsmHandler* oHandler );
void Reg_0026_0027_Tra_0027_0032( struct Reg_0026_0027Struct* this, TsmHandler* oHandler );
void Reg_0026_0027_Tra_0027_0033( struct Reg_0026_0027Struct* this, TsmHandler* oHandler );
int Reg_0026_0027_GetProspect( struct Reg_0026_0027Struct* this, int PortId, int Command );
TsmBool Reg_0026_0027_ExecuteTransition( struct Reg_0026_0027Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> InitialState ) */
typedef struct Ini_0034_0035Struct
{
#include "TsmPseudo_fields.h"
  TsmTransition* aTransitions[ 1 ];
} Ini_0034_0035;

Ini_0034_0035* Ini_0034_0035_Ctor( TsmBase* oParent );
void Ini_0034_0035_Initial( struct Ini_0034_0035Struct* this, TsmHandler* oHandler );
void Ini_0034_0035_AtEntry( struct Ini_0034_0035Struct* this, TsmHandler* oHandler );
TsmBool Ini_0034_0035_ExecuteTransition( struct Ini_0034_0035Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> Answered ) */
typedef struct Lea_0034_0036Struct
{
#include "TsmLeaf_fields.h"
  TsmTransition* aTransitions[ 1 ];
} Lea_0034_0036;

Lea_0034_0036* Lea_0034_0036_Ctor( TsmBase* oParent );
void Lea_0034_0036_Tra_0034_0038( struct Lea_0034_0036Struct* this, TsmHandler* oHandler );
void Lea_0034_0036_Initial( struct Lea_0034_0036Struct* this, TsmHandler* oHandler );
void Lea_0034_0036_Tra_0034_0040( struct Lea_0034_0036Struct* this, TsmHandler* oHandler );
void Lea_0034_0036_rp_In2___CbQuestion( struct Lea_0034_0036Struct* this, char* sQuestion, TsmHandler* oHandler );
void Lea_0034_0036_AtEntry( struct Lea_0034_0036Struct* this, TsmHandler* oHandler );
int Lea_0034_0036_GetProspect( struct Lea_0034_0036Struct* this, int PortId, int Command );
void Lea_0034_0036_ExecuteTrigger( struct Lea_0034_0036Struct* this, TsmHandler* oHandler );
TsmBool Lea_0034_0036_ExecuteTransition( struct Lea_0034_0036Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> Thinking ) */
typedef struct Lea_0034_0037Struct
{
#include "TsmLeaf_fields.h"
  const int* aNatives;
  TsmTransition* aTransitions[ 1 ];
} Lea_0034_0037;

Lea_0034_0037* Lea_0034_0037_Ctor( TsmBase* oParent );
void Lea_0034_0037_Initial( struct Lea_0034_0037Struct* this, TsmHandler* oHandler );
void Lea_0034_0037_Tra_0034_0039( struct Lea_0034_0037Struct* this, TsmHandler* oHandler );
void Lea_0034_0037_AtEntry( struct Lea_0034_0037Struct* this, TsmHandler* oHandler );
void Lea_0034_0037_AtExit( struct Lea_0034_0037Struct* this, TsmHandler* oHandler );
int Lea_0034_0037_GetProspect( struct Lea_0034_0037Struct* this, int PortId, int Command );
void Lea_0034_0037_ExecuteTrigger( struct Lea_0034_0037Struct* this, TsmHandler* oHandler );
TsmBool Lea_0034_0037_ExecuteTransition( struct Lea_0034_0037Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >) */
typedef struct Reg_0026_0034Struct
{
#include "TsmRegion_fields.h"
  Ini_0034_0035* oIni_0034_0035; /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> InitialState ) */
  Lea_0034_0036* oLea_0034_0036; /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> Answered ) */
  Lea_0034_0037* oLea_0034_0037; /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >> Thinking ) */
  TsmState* aStates[ 3 ];
} Reg_0026_0034;

Reg_0026_0034* Reg_0026_0034_Ctor( TsmBase* oParent );
void Reg_0026_0034_Initial( struct Reg_0026_0034Struct* this, TsmHandler* oHandler );
void Reg_0026_0034_Tra_0034_0038( struct Reg_0026_0034Struct* this, TsmHandler* oHandler );
void Reg_0026_0034_Tra_0034_0040( struct Reg_0026_0034Struct* this, TsmHandler* oHandler );
void Reg_0026_0034_Tra_0034_0039( struct Reg_0026_0034Struct* this, TsmHandler* oHandler );
int Reg_0026_0034_GetProspect( struct Reg_0026_0034Struct* this, int PortId, int Command );
TsmBool Reg_0026_0034_ExecuteTransition( struct Reg_0026_0034Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState ) */
typedef struct Com_0024_0026Struct
{
#include "TsmCompound_fields.h"
  Reg_0026_0027* oReg_0026_0027; /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >) */
  Reg_0026_0034* oReg_0026_0034; /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState >) */
  TsmRegion* aRegions[ 2 ];
} Com_0024_0026;

Com_0024_0026* Com_0024_0026_Ctor( TsmBase* oParent );
void Com_0024_0026_Tra_0024_0041( struct Com_0024_0026Struct* this, TsmHandler* oHandler );
void Com_0024_0026_AtEntry( struct Com_0024_0026Struct* this, TsmHandler* oHandler );
TsmBool Com_0024_0026_ExecuteTransition( struct Com_0024_0026Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >) */
typedef struct Reg_0023_0024Struct
{
#include "TsmRegion_fields.h"
  Ini_0024_0025* oIni_0024_0025; /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> InitialState ) */
  Com_0024_0026* oCom_0024_0026; /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >> CompoundState ) */
  TsmState* aStates[ 2 ];
} Reg_0023_0024;

Reg_0023_0024* Reg_0023_0024_Ctor( TsmBase* oParent );
void Reg_0023_0024_Initial( struct Reg_0023_0024Struct* this, TsmHandler* oHandler );
void Reg_0023_0024_Tra_0024_0041( struct Reg_0023_0024Struct* this, TsmHandler* oHandler );
int Reg_0023_0024_GetProspect( struct Reg_0023_0024Struct* this, int PortId, int Command );
TsmBool Reg_0023_0024_ExecuteTransition( struct Reg_0023_0024Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm ) */
typedef struct Fsm_0020_0023Struct
{
#include "TsmFsm_fields.h"
  Reg_0023_0024* oReg_0023_0024; /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm >) */
  TsmRegion* aRegions[ 1 ];
} Fsm_0020_0023;

Fsm_0020_0023* Fsm_0020_0023_Ctor( TsmBase* oParent );
void Fsm_0020_0023_AtEntry( struct Fsm_0020_0023Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass ) */
typedef struct Cla_0018_0020Struct
{
#include "TsmClass_fields.h"
  Fsm_0020_0023* oFsm_0020_0023; /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > TwinMockFsm ) */
  TsmIPort_ICbTwin* TsmPI__rp_In2; /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > rp_In2 ) */
  TsmIPort_ICbTwin* pp_Out2; /* ( Xmi > Data > Repository > Twin > TwinMock > TwinMockClass > pp_Out2 ) */
  TsmPCPort mPCMessager;
  char* sQuestion;
  char* sAnswer;
  TsmFsm* aFsms[ 1 ];
} Cla_0018_0020;

Cla_0018_0020* Cla_0018_0020_Ctor( TsmBase* oParent, char* sInstanceName );
TsmInterfacePort* Cla_0018_0020_GetProvidedInterface( struct Cla_0018_0020Struct* this, char* sPortName );
void Cla_0018_0020_SetRequiredInterface( struct Cla_0018_0020Struct* this, char* sPortName, TsmInterfacePort* oProvidedInterface );
void Cla_0018_0020_ExecuteTrigger( struct Cla_0018_0020Struct* this, TsmTrigger* oTrigger );
void Cla_0018_0020_Function_1007( struct Cla_0018_0020Struct* this, TsmHandler* oHandler );
void Cla_0018_0020_Function_1008( struct Cla_0018_0020Struct* this, TsmHandler* oHandler );
void Cla_0018_0020_TsmInitialise( struct Cla_0018_0020Struct* this, void* oObject );
void Cla_0018_0020_TsmConnect( struct Cla_0018_0020Struct* this, void* oObject );
void Cla_0018_0020_TsmPrepare( struct Cla_0018_0020Struct* this, void* oObject );
void Cla_0018_0020_Gtor( struct Cla_0018_0020Struct* this );

 /* ( Xmi > Data > Repository > Twin > TwinMock ) */
typedef struct Com_0016_0018Struct
{
#include "TsmAComponent_fields.h"
  TsmClass* aClasses[ 1 ];
  Cla_0018_0020* Twin; /* ( Xmi > Data > Repository > Twin > TwinMock > Twin ) */
  TsmIPort_ICbTwin* TsmPI__In2; /* ( Xmi > Data > Repository > Twin > TwinMock > In2 ) */
  TsmACPort TsmMr__In2;
} Com_0016_0018;

Com_0016_0018* Com_0016_0018_Ctor( TsmBase* oParent, char* sInstanceName );
TsmInterfacePort* Com_0016_0018_GetProvidedInterface( struct Com_0016_0018Struct* this, char* sPortName );
void Com_0016_0018_SetRequiredInterface( struct Com_0016_0018Struct* this, char* sPortName, TsmInterfacePort* oProvidedInterface );
void Com_0016_0018_TsmInitialise( struct Com_0016_0018Struct* this, void* oObject );
void Com_0016_0018_TsmConnect( struct Com_0016_0018Struct* this, void* oObject );
void Com_0016_0018_Gtor( struct Com_0016_0018Struct* this );

 /* ( Xmi > Data > Architecture > TwinsTest ) */
typedef struct Com_0007_0011Struct
{
#include "TsmPComponent_fields.h"
  TsmComponent* aComponents[ 2 ];
  Com_0016_0018* Alice; /* ( Xmi > Data > Architecture > TwinsTest > Alice ) */
  Com_0016_0018* Bob; /* ( Xmi > Data > Architecture > TwinsTest > Bob ) */
} Com_0007_0011;

Com_0007_0011* Com_0007_0011_Ctor( TsmBase* oParent, char* sInstanceName );
void Com_0007_0011_TsmConnect( struct Com_0007_0011Struct* this, void* oObject );

/********************************************************************
 * PACKAGE: ( Xmi > Data > Architecture > Sequence Diagrams )
 ********************************************************************/

 /* ( Xmi > Data > Architecture > Sequence Diagrams ) */
typedef struct Pac_0007_0014Struct
{
#include "TsmPackage_fields.h"
} Pac_0007_0014;

Pac_0007_0014* Pac_0007_0014_Ctor( TsmBase* oParent );

/********************************************************************
 * PACKAGE: ( Xmi > Data > Architecture )
 ********************************************************************/

 /* ( Xmi > Data > Architecture ) */
typedef struct Pac_0006_0007Struct
{
#include "TsmPackage_fields.h"
} Pac_0006_0007;

Pac_0006_0007* Pac_0006_0007_Ctor( TsmBase* oParent );

 /* ( Xmi > Data > Repository > Twin > CharArray ) */
typedef struct Cla_0016_0017Struct
{
#include "TsmClass_fields.h"
} Cla_0016_0017;

Cla_0016_0017* Cla_0016_0017_Ctor( TsmBase* oParent, char* sInstanceName );

/********************************************************************
 * PACKAGE: ( Xmi > Data > Repository > Twin )
 ********************************************************************/

 /* ( Xmi > Data > Repository > Twin ) */
typedef struct Pac_0015_0016Struct
{
#include "TsmPackage_fields.h"
} Pac_0015_0016;

Pac_0015_0016* Pac_0015_0016_Ctor( TsmBase* oParent );

/********************************************************************
 * PACKAGE: ( Xmi > Data > Repository )
 ********************************************************************/

 /* ( Xmi > Data > Repository ) */
typedef struct Pac_0006_0015Struct
{
#include "TsmPackage_fields.h"
} Pac_0006_0015;

Pac_0006_0015* Pac_0006_0015_Ctor( TsmBase* oParent );

/********************************************************************
 * PACKAGE: ( Xmi > Data > TismStereotypes )
 ********************************************************************/

 /* ( Xmi > Data > TismStereotypes ) */
typedef struct Pac_0006_0086Struct
{
#include "TsmPackage_fields.h"
} Pac_0006_0086;

Pac_0006_0086* Pac_0006_0086_Ctor( TsmBase* oParent );

 /* ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm >> InitialState ) */
typedef struct Ini_0092_0093Struct
{
#include "TsmPseudo_fields.h"
  TsmTransition* aTransitions[ 1 ];
} Ini_0092_0093;

Ini_0092_0093* Ini_0092_0093_Ctor( TsmBase* oParent );
void Ini_0092_0093_Initial( struct Ini_0092_0093Struct* this, TsmHandler* oHandler );
void Ini_0092_0093_AtEntry( struct Ini_0092_0093Struct* this, TsmHandler* oHandler );
TsmBool Ini_0092_0093_ExecuteTransition( struct Ini_0092_0093Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm >> Idle ) */
typedef struct Lea_0092_0094Struct
{
#include "TsmLeaf_fields.h"
  const int* aNatives;
  TsmTransition* aTransitions[ 1 ];
} Lea_0092_0094;

Lea_0092_0094* Lea_0092_0094_Ctor( TsmBase* oParent );
void Lea_0092_0094_Tra_0092_0096( struct Lea_0092_0094Struct* this, TsmHandler* oHandler );
void Lea_0092_0094_Initial( struct Lea_0092_0094Struct* this, TsmHandler* oHandler );
void Lea_0092_0094_Tra_0092_0098( struct Lea_0092_0094Struct* this, TsmHandler* oHandler );
void Lea_0092_0094_AtEntry( struct Lea_0092_0094Struct* this, TsmHandler* oHandler );
void Lea_0092_0094_AtExit( struct Lea_0092_0094Struct* this, TsmHandler* oHandler );
int Lea_0092_0094_GetProspect( struct Lea_0092_0094Struct* this, int PortId, int Command );
void Lea_0092_0094_ExecuteTrigger( struct Lea_0092_0094Struct* this, TsmHandler* oHandler );
TsmBool Lea_0092_0094_ExecuteTransition( struct Lea_0092_0094Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm >> Asking ) */
typedef struct Lea_0092_0095Struct
{
#include "TsmLeaf_fields.h"
  TsmTransition* aTransitions[ 1 ];
} Lea_0092_0095;

Lea_0092_0095* Lea_0092_0095_Ctor( TsmBase* oParent );
void Lea_0092_0095_Initial( struct Lea_0092_0095Struct* this, TsmHandler* oHandler );
void Lea_0092_0095_Tra_0092_0097( struct Lea_0092_0095Struct* this, TsmHandler* oHandler );
void Lea_0092_0095_Port___CbReply( struct Lea_0092_0095Struct* this, char* sReply, TsmHandler* oHandler );
void Lea_0092_0095_AtEntry( struct Lea_0092_0095Struct* this, TsmHandler* oHandler );
int Lea_0092_0095_GetProspect( struct Lea_0092_0095Struct* this, int PortId, int Command );
void Lea_0092_0095_ExecuteTrigger( struct Lea_0092_0095Struct* this, TsmHandler* oHandler );
TsmBool Lea_0092_0095_ExecuteTransition( struct Lea_0092_0095Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm >) */
typedef struct Reg_0091_0092Struct
{
#include "TsmRegion_fields.h"
  Ini_0092_0093* oIni_0092_0093; /* ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm >> InitialState ) */
  Lea_0092_0094* oLea_0092_0094; /* ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm >> Idle ) */
  Lea_0092_0095* oLea_0092_0095; /* ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm >> Asking ) */
  TsmState* aStates[ 3 ];
} Reg_0091_0092;

Reg_0091_0092* Reg_0091_0092_Ctor( TsmBase* oParent );
void Reg_0091_0092_Initial( struct Reg_0091_0092Struct* this, TsmHandler* oHandler );
void Reg_0091_0092_Tra_0092_0096( struct Reg_0091_0092Struct* this, TsmHandler* oHandler );
void Reg_0091_0092_Tra_0092_0097( struct Reg_0091_0092Struct* this, TsmHandler* oHandler );
void Reg_0091_0092_Tra_0092_0098( struct Reg_0091_0092Struct* this, TsmHandler* oHandler );
int Reg_0091_0092_GetProspect( struct Reg_0091_0092Struct* this, int PortId, int Command );
TsmBool Reg_0091_0092_ExecuteTransition( struct Reg_0091_0092Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm ) */
typedef struct Fsm_0089_0091Struct
{
#include "TsmFsm_fields.h"
  Reg_0091_0092* oReg_0091_0092; /* ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm >) */
  TsmRegion* aRegions[ 1 ];
} Fsm_0089_0091;

Fsm_0089_0091* Fsm_0089_0091_Ctor( TsmBase* oParent );
void Fsm_0089_0091_AtEntry( struct Fsm_0089_0091Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Protocols > OracleProtocol > OracleClient ) */
typedef struct Cla_0088_0089Struct
{
#include "TsmProtocolClass_fields.h"
  Fsm_0089_0091* oFsm_0089_0091; /* ( Xmi > Data > Protocols > OracleProtocol > OracleClient > OracleClientPsm ) */
  TsmIPort_IOracle* Port; /* ( Xmi > Data > Protocols > OracleProtocol > OracleClient > Port ) */
  TsmIPort_ICbOracle* TsmPI__Port; /* ( Xmi > Data > Protocols > OracleProtocol > OracleClient > Port ) */
  TsmPCPort mPCMessager;
  char* sAsk;
  TsmFsm* aFsms[ 1 ];
} Cla_0088_0089;

Cla_0088_0089* Cla_0088_0089_Ctor( TsmBase* oParent, char* sInstanceName );
TsmInterfacePort* Cla_0088_0089_GetProvidedInterface( struct Cla_0088_0089Struct* this, char* sPortName );
void Cla_0088_0089_SetRequiredInterface( struct Cla_0088_0089Struct* this, char* sPortName, TsmInterfacePort* oProvidedInterface );
void Cla_0088_0089_ExecuteTrigger( struct Cla_0088_0089Struct* this, TsmTrigger* oTrigger );
void Cla_0088_0089_Function_1009( struct Cla_0088_0089Struct* this, TsmHandler* oHandler );
void Cla_0088_0089_TsmInitialise( struct Cla_0088_0089Struct* this, void* oObject );
void Cla_0088_0089_TsmConnect( struct Cla_0088_0089Struct* this, void* oObject );
void Cla_0088_0089_TsmPrepare( struct Cla_0088_0089Struct* this, void* oObject );
void Cla_0088_0089_Gtor( struct Cla_0088_0089Struct* this );

 /* ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm >> InitialState ) */
typedef struct Ini_0102_0103Struct
{
#include "TsmPseudo_fields.h"
  TsmTransition* aTransitions[ 1 ];
} Ini_0102_0103;

Ini_0102_0103* Ini_0102_0103_Ctor( TsmBase* oParent );
void Ini_0102_0103_Initial( struct Ini_0102_0103Struct* this, TsmHandler* oHandler );
void Ini_0102_0103_AtEntry( struct Ini_0102_0103Struct* this, TsmHandler* oHandler );
TsmBool Ini_0102_0103_ExecuteTransition( struct Ini_0102_0103Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm >> Idle ) */
typedef struct Lea_0102_0104Struct
{
#include "TsmLeaf_fields.h"
  TsmTransition* aTransitions[ 1 ];
} Lea_0102_0104;

Lea_0102_0104* Lea_0102_0104_Ctor( TsmBase* oParent );
void Lea_0102_0104_Tra_0102_0106( struct Lea_0102_0104Struct* this, TsmHandler* oHandler );
void Lea_0102_0104_Initial( struct Lea_0102_0104Struct* this, TsmHandler* oHandler );
void Lea_0102_0104_Tra_0102_0108( struct Lea_0102_0104Struct* this, TsmHandler* oHandler );
void Lea_0102_0104_Port___Ask( struct Lea_0102_0104Struct* this, char* sAsk, TsmHandler* oHandler );
void Lea_0102_0104_AtEntry( struct Lea_0102_0104Struct* this, TsmHandler* oHandler );
int Lea_0102_0104_GetProspect( struct Lea_0102_0104Struct* this, int PortId, int Command );
void Lea_0102_0104_ExecuteTrigger( struct Lea_0102_0104Struct* this, TsmHandler* oHandler );
TsmBool Lea_0102_0104_ExecuteTransition( struct Lea_0102_0104Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm >> Asked ) */
typedef struct Lea_0102_0105Struct
{
#include "TsmLeaf_fields.h"
  const int* aNatives;
  TsmTransition* aTransitions[ 1 ];
} Lea_0102_0105;

Lea_0102_0105* Lea_0102_0105_Ctor( TsmBase* oParent );
void Lea_0102_0105_Initial( struct Lea_0102_0105Struct* this, TsmHandler* oHandler );
void Lea_0102_0105_Tra_0102_0107( struct Lea_0102_0105Struct* this, TsmHandler* oHandler );
void Lea_0102_0105_AtEntry( struct Lea_0102_0105Struct* this, TsmHandler* oHandler );
void Lea_0102_0105_AtExit( struct Lea_0102_0105Struct* this, TsmHandler* oHandler );
int Lea_0102_0105_GetProspect( struct Lea_0102_0105Struct* this, int PortId, int Command );
void Lea_0102_0105_ExecuteTrigger( struct Lea_0102_0105Struct* this, TsmHandler* oHandler );
TsmBool Lea_0102_0105_ExecuteTransition( struct Lea_0102_0105Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm >) */
typedef struct Reg_0101_0102Struct
{
#include "TsmRegion_fields.h"
  Ini_0102_0103* oIni_0102_0103; /* ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm >> InitialState ) */
  Lea_0102_0104* oLea_0102_0104; /* ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm >> Idle ) */
  Lea_0102_0105* oLea_0102_0105; /* ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm >> Asked ) */
  TsmState* aStates[ 3 ];
} Reg_0101_0102;

Reg_0101_0102* Reg_0101_0102_Ctor( TsmBase* oParent );
void Reg_0101_0102_Initial( struct Reg_0101_0102Struct* this, TsmHandler* oHandler );
void Reg_0101_0102_Tra_0102_0106( struct Reg_0101_0102Struct* this, TsmHandler* oHandler );
void Reg_0101_0102_Tra_0102_0108( struct Reg_0101_0102Struct* this, TsmHandler* oHandler );
void Reg_0101_0102_Tra_0102_0107( struct Reg_0101_0102Struct* this, TsmHandler* oHandler );
int Reg_0101_0102_GetProspect( struct Reg_0101_0102Struct* this, int PortId, int Command );
TsmBool Reg_0101_0102_ExecuteTransition( struct Reg_0101_0102Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm ) */
typedef struct Fsm_0099_0101Struct
{
#include "TsmFsm_fields.h"
  Reg_0101_0102* oReg_0101_0102; /* ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm >) */
  TsmRegion* aRegions[ 1 ];
} Fsm_0099_0101;

Fsm_0099_0101* Fsm_0099_0101_Ctor( TsmBase* oParent );
void Fsm_0099_0101_AtEntry( struct Fsm_0099_0101Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Protocols > OracleProtocol > OracleServer ) */
typedef struct Cla_0088_0099Struct
{
#include "TsmProtocolClass_fields.h"
  Fsm_0099_0101* oFsm_0099_0101; /* ( Xmi > Data > Protocols > OracleProtocol > OracleServer > OracleServerPsm ) */
  TsmIPort_IOracle* TsmPI__Port; /* ( Xmi > Data > Protocols > OracleProtocol > OracleServer > Port ) */
  TsmIPort_ICbOracle* Port; /* ( Xmi > Data > Protocols > OracleProtocol > OracleServer > Port ) */
  TsmPSPort mPSMessager;
  char* MyAsk;
  CharArray MyReply;
  TsmFsm* aFsms[ 1 ];
} Cla_0088_0099;

Cla_0088_0099* Cla_0088_0099_Ctor( TsmBase* oParent, char* sInstanceName );
TsmInterfacePort* Cla_0088_0099_GetProvidedInterface( struct Cla_0088_0099Struct* this, char* sPortName );
void Cla_0088_0099_SetRequiredInterface( struct Cla_0088_0099Struct* this, char* sPortName, TsmInterfacePort* oProvidedInterface );
void Cla_0088_0099_ExecuteTrigger( struct Cla_0088_0099Struct* this, TsmTrigger* oTrigger );
void Cla_0088_0099_Function_1010( struct Cla_0088_0099Struct* this, TsmHandler* oHandler );
void Cla_0088_0099_Function_1017( struct Cla_0088_0099Struct* this, TsmHandler* oHandler );
void Cla_0088_0099_TsmInitialise( struct Cla_0088_0099Struct* this, void* oObject );
void Cla_0088_0099_TsmConnect( struct Cla_0088_0099Struct* this, void* oObject );
void Cla_0088_0099_TsmPrepare( struct Cla_0088_0099Struct* this, void* oObject );
void Cla_0088_0099_Gtor( struct Cla_0088_0099Struct* this );

/********************************************************************
 * PACKAGE: ( Xmi > Data > Protocols > OracleProtocol )
 ********************************************************************/

 /* ( Xmi > Data > Protocols > OracleProtocol ) */
typedef struct Pac_0087_0088Struct
{
#include "TsmPackage_fields.h"
} Pac_0087_0088;

Pac_0087_0088* Pac_0087_0088_Ctor( TsmBase* oParent );

 /* ( Xmi > Data > Protocols > TwinProtocol > TwinServer > TwinServerPsm >> InitialState ) */
typedef struct Ini_0113_0114Struct
{
#include "TsmPseudo_fields.h"
  TsmTransition* aTransitions[ 1 ];
} Ini_0113_0114;

Ini_0113_0114* Ini_0113_0114_Ctor( TsmBase* oParent );
void Ini_0113_0114_Initial( struct Ini_0113_0114Struct* this, TsmHandler* oHandler );
void Ini_0113_0114_AtEntry( struct Ini_0113_0114Struct* this, TsmHandler* oHandler );
TsmBool Ini_0113_0114_ExecuteTransition( struct Ini_0113_0114Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Protocols > TwinProtocol > TwinServer > TwinServerPsm >> Idle ) */
typedef struct Lea_0113_0115Struct
{
#include "TsmLeaf_fields.h"
  const int* aNatives;
  TsmTransition* aTransitions[ 2 ];
} Lea_0113_0115;

Lea_0113_0115* Lea_0113_0115_Ctor( TsmBase* oParent );
void Lea_0113_0115_Tra_0113_0116( struct Lea_0113_0115Struct* this, TsmHandler* oHandler );
void Lea_0113_0115_Initial( struct Lea_0113_0115Struct* this, TsmHandler* oHandler );
void Lea_0113_0115_Tra_0113_0117( struct Lea_0113_0115Struct* this, TsmHandler* oHandler );
void Lea_0113_0115_Tra_0113_0118( struct Lea_0113_0115Struct* this, TsmHandler* oHandler );
void Lea_0113_0115_AtEntry( struct Lea_0113_0115Struct* this, TsmHandler* oHandler );
void Lea_0113_0115_AtExit( struct Lea_0113_0115Struct* this, TsmHandler* oHandler );
int Lea_0113_0115_GetProspect( struct Lea_0113_0115Struct* this, int PortId, int Command );
void Lea_0113_0115_ExecuteTrigger( struct Lea_0113_0115Struct* this, TsmHandler* oHandler );
TsmBool Lea_0113_0115_ExecuteTransition( struct Lea_0113_0115Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Protocols > TwinProtocol > TwinServer > TwinServerPsm >) */
typedef struct Reg_0112_0113Struct
{
#include "TsmRegion_fields.h"
  Ini_0113_0114* oIni_0113_0114; /* ( Xmi > Data > Protocols > TwinProtocol > TwinServer > TwinServerPsm >> InitialState ) */
  Lea_0113_0115* oLea_0113_0115; /* ( Xmi > Data > Protocols > TwinProtocol > TwinServer > TwinServerPsm >> Idle ) */
  TsmState* aStates[ 2 ];
} Reg_0112_0113;

Reg_0112_0113* Reg_0112_0113_Ctor( TsmBase* oParent );
void Reg_0112_0113_Initial( struct Reg_0112_0113Struct* this, TsmHandler* oHandler );
void Reg_0112_0113_Tra_0113_0116( struct Reg_0112_0113Struct* this, TsmHandler* oHandler );
int Reg_0112_0113_GetProspect( struct Reg_0112_0113Struct* this, int PortId, int Command );
TsmBool Reg_0112_0113_ExecuteTransition( struct Reg_0112_0113Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Protocols > TwinProtocol > TwinServer > TwinServerPsm ) */
typedef struct Fsm_0110_0112Struct
{
#include "TsmFsm_fields.h"
  Reg_0112_0113* oReg_0112_0113; /* ( Xmi > Data > Protocols > TwinProtocol > TwinServer > TwinServerPsm >) */
  TsmRegion* aRegions[ 1 ];
} Fsm_0110_0112;

Fsm_0110_0112* Fsm_0110_0112_Ctor( TsmBase* oParent );
void Fsm_0110_0112_AtEntry( struct Fsm_0110_0112Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Protocols > TwinProtocol > TwinServer ) */
typedef struct Cla_0109_0110Struct
{
#include "TsmProtocolClass_fields.h"
  Fsm_0110_0112* oFsm_0110_0112; /* ( Xmi > Data > Protocols > TwinProtocol > TwinServer > TwinServerPsm ) */
  TsmIPort_ICbTwin* Port; /* ( Xmi > Data > Protocols > TwinProtocol > TwinServer > Port ) */
  char* sQuestion;
  char* sAnswer;
  TsmFsm* aFsms[ 1 ];
} Cla_0109_0110;

Cla_0109_0110* Cla_0109_0110_Ctor( TsmBase* oParent, char* sInstanceName );
void Cla_0109_0110_SetRequiredInterface( struct Cla_0109_0110Struct* this, char* sPortName, TsmInterfacePort* oProvidedInterface );
void Cla_0109_0110_ExecuteTrigger( struct Cla_0109_0110Struct* this, TsmTrigger* oTrigger );
void Cla_0109_0110_Function_1011( struct Cla_0109_0110Struct* this, TsmHandler* oHandler );
void Cla_0109_0110_Function_1012( struct Cla_0109_0110Struct* this, TsmHandler* oHandler );
void Cla_0109_0110_TsmPrepare( struct Cla_0109_0110Struct* this, void* oObject );

 /* ( Xmi > Data > Protocols > TwinProtocol > TwinClient > TwinClientPsm >> InitialState ) */
typedef struct Ini_0122_0123Struct
{
#include "TsmPseudo_fields.h"
  TsmTransition* aTransitions[ 1 ];
} Ini_0122_0123;

Ini_0122_0123* Ini_0122_0123_Ctor( TsmBase* oParent );
void Ini_0122_0123_Initial( struct Ini_0122_0123Struct* this, TsmHandler* oHandler );
void Ini_0122_0123_AtEntry( struct Ini_0122_0123Struct* this, TsmHandler* oHandler );
TsmBool Ini_0122_0123_ExecuteTransition( struct Ini_0122_0123Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Protocols > TwinProtocol > TwinClient > TwinClientPsm >> Idle ) */
typedef struct Lea_0122_0124Struct
{
#include "TsmLeaf_fields.h"
  TsmTransition* aTransitions[ 2 ];
} Lea_0122_0124;

Lea_0122_0124* Lea_0122_0124_Ctor( TsmBase* oParent );
void Lea_0122_0124_Tra_0122_0125( struct Lea_0122_0124Struct* this, TsmHandler* oHandler );
void Lea_0122_0124_Initial( struct Lea_0122_0124Struct* this, TsmHandler* oHandler );
void Lea_0122_0124_Tra_0122_0126( struct Lea_0122_0124Struct* this, TsmHandler* oHandler );
void Lea_0122_0124_Port___CbQuestion( struct Lea_0122_0124Struct* this, char* sQuestion, TsmHandler* oHandler );
void Lea_0122_0124_Tra_0122_0127( struct Lea_0122_0124Struct* this, TsmHandler* oHandler );
void Lea_0122_0124_Port___CbAnswer( struct Lea_0122_0124Struct* this, char* sAnswer, TsmHandler* oHandler );
void Lea_0122_0124_AtEntry( struct Lea_0122_0124Struct* this, TsmHandler* oHandler );
int Lea_0122_0124_GetProspect( struct Lea_0122_0124Struct* this, int PortId, int Command );
void Lea_0122_0124_ExecuteTrigger( struct Lea_0122_0124Struct* this, TsmHandler* oHandler );
TsmBool Lea_0122_0124_ExecuteTransition( struct Lea_0122_0124Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Protocols > TwinProtocol > TwinClient > TwinClientPsm >) */
typedef struct Reg_0121_0122Struct
{
#include "TsmRegion_fields.h"
  Ini_0122_0123* oIni_0122_0123; /* ( Xmi > Data > Protocols > TwinProtocol > TwinClient > TwinClientPsm >> InitialState ) */
  Lea_0122_0124* oLea_0122_0124; /* ( Xmi > Data > Protocols > TwinProtocol > TwinClient > TwinClientPsm >> Idle ) */
  TsmState* aStates[ 2 ];
} Reg_0121_0122;

Reg_0121_0122* Reg_0121_0122_Ctor( TsmBase* oParent );
void Reg_0121_0122_Initial( struct Reg_0121_0122Struct* this, TsmHandler* oHandler );
void Reg_0121_0122_Tra_0122_0125( struct Reg_0121_0122Struct* this, TsmHandler* oHandler );
int Reg_0121_0122_GetProspect( struct Reg_0121_0122Struct* this, int PortId, int Command );
TsmBool Reg_0121_0122_ExecuteTransition( struct Reg_0121_0122Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Protocols > TwinProtocol > TwinClient > TwinClientPsm ) */
typedef struct Fsm_0119_0121Struct
{
#include "TsmFsm_fields.h"
  Reg_0121_0122* oReg_0121_0122; /* ( Xmi > Data > Protocols > TwinProtocol > TwinClient > TwinClientPsm >) */
  TsmRegion* aRegions[ 1 ];
} Fsm_0119_0121;

Fsm_0119_0121* Fsm_0119_0121_Ctor( TsmBase* oParent );
void Fsm_0119_0121_AtEntry( struct Fsm_0119_0121Struct* this, TsmHandler* oHandler );

 /* ( Xmi > Data > Protocols > TwinProtocol > TwinClient ) */
typedef struct Cla_0109_0119Struct
{
#include "TsmProtocolClass_fields.h"
  Fsm_0119_0121* oFsm_0119_0121; /* ( Xmi > Data > Protocols > TwinProtocol > TwinClient > TwinClientPsm ) */
  TsmIPort_ICbTwin* TsmPI__Port; /* ( Xmi > Data > Protocols > TwinProtocol > TwinClient > Port ) */
  TsmPCPort mPCMessager;
  TsmFsm* aFsms[ 1 ];
} Cla_0109_0119;

Cla_0109_0119* Cla_0109_0119_Ctor( TsmBase* oParent, char* sInstanceName );
TsmInterfacePort* Cla_0109_0119_GetProvidedInterface( struct Cla_0109_0119Struct* this, char* sPortName );
void Cla_0109_0119_ExecuteTrigger( struct Cla_0109_0119Struct* this, TsmTrigger* oTrigger );
void Cla_0109_0119_TsmInitialise( struct Cla_0109_0119Struct* this, void* oObject );
void Cla_0109_0119_TsmConnect( struct Cla_0109_0119Struct* this, void* oObject );
void Cla_0109_0119_TsmPrepare( struct Cla_0109_0119Struct* this, void* oObject );
void Cla_0109_0119_Gtor( struct Cla_0109_0119Struct* this );

/********************************************************************
 * PACKAGE: ( Xmi > Data > Protocols > TwinProtocol )
 ********************************************************************/

 /* ( Xmi > Data > Protocols > TwinProtocol ) */
typedef struct Pac_0087_0109Struct
{
#include "TsmPackage_fields.h"
} Pac_0087_0109;

Pac_0087_0109* Pac_0087_0109_Ctor( TsmBase* oParent );

/********************************************************************
 * PACKAGE: ( Xmi > Data > Protocols )
 ********************************************************************/

 /* ( Xmi > Data > Protocols ) */
typedef struct Pac_0006_0087Struct
{
#include "TsmPackage_fields.h"
} Pac_0006_0087;

Pac_0006_0087* Pac_0006_0087_Ctor( TsmBase* oParent );

 /* ( Xmi ) */
typedef struct TsmSystemStruct
{
#include "TsmExecComponent_fields.h"
  TsmComponent* aComponents[ 1 ];
  Com_0007_0011* TwinsTest; /* ( Xmi > Data > Architecture > TwinsTest ) */
} TsmSystem;

TsmSystem* TsmSystem_Ctor( TsmBase* oParent );

#ifdef __cplusplus
}
#endif 
#endif
